/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.SysConfig.SHotdeployClass
 *  fire.pb.gm.ExtraCommandClassLoader
 *  fire.pb.main.ConfigManager
 *  fire.pb.main.ModuleInterface
 *  fire.pb.main.ReloadResult
 *  mkdb.Procedure
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 */
package fire.pb.hotdeploy;

import fire.pb.SysConfig.SHotdeployClass;
import fire.pb.gm.ExtraCommandClassLoader;
import fire.pb.main.ConfigManager;
import fire.pb.main.ModuleInterface;
import fire.pb.main.ReloadResult;
import java.lang.reflect.Constructor;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;
import mkdb.Procedure;
import mkio.Protocol;
import org.apache.log4j.Logger;

public class Module
implements ModuleInterface {
    static Logger logger = Logger.getLogger(Module.class);
    static boolean hasNewProcedureClass = false;
    static boolean hasNewProtocolClass = false;
    static Map<String, Class<?>> classes = new HashMap();

    public void exit() {
    }

    public void init() {
        try {
            this.loadClassFromCache();
        }
        catch (ClassNotFoundException e) {
            logger.info((Object)"服务器启动时加载proc的对应Class出错，服务器已经加载gs/hotdeploy.jar!!!，请检查/gamedata/xml/auto/fire.pb.SystemSetting.SHotdeployClass.xml文件");
        }
    }

    public ReloadResult loadClassFromCache() throws ClassNotFoundException {
        classes.clear();
        String jarfilename = ConfigManager.getInstance().getPropConf("sys").getProperty("sys.hotdeploy.jarfile");
        ExtraCommandClassLoader clzloader = new ExtraCommandClassLoader(".", jarfilename);
        TreeMap confs = ConfigManager.getInstance().getConf(SHotdeployClass.class);
        for (SHotdeployClass sHotdeployClass : confs.values()) {
            if (clzloader.loadByMe(sHotdeployClass.newClassName)) {
                Class newClass = clzloader.loadClass(sHotdeployClass.newClassName);
                if (Procedure.class.isAssignableFrom(newClass)) {
                    hasNewProcedureClass = true;
                } else if (Protocol.class.isAssignableFrom(newClass)) {
                    hasNewProtocolClass = true;
                }
                classes.put(sHotdeployClass.oldClassName, clzloader.loadClass(sHotdeployClass.newClassName));
                continue;
            }
            return new ReloadResult(false);
        }
        return new ReloadResult(true);
    }

    public ReloadResult reload() {
        ReloadResult result = null;
        try {
            result = this.loadClassFromCache();
        }
        catch (ClassNotFoundException e) {
            logger.error((Object)"服务器热加载proc的时候Class反射出错：", (Throwable)e);
        }
        return result;
    }

    public static Procedure getHotdeployProcedure(String className, Procedure oldProc) throws Exception {
        Class<?> newProcedureClass = classes.get(className);
        if (newProcedureClass != null) {
            Constructor<?> constructor = newProcedureClass.getConstructor(Procedure.class);
            return (Procedure)constructor.newInstance(oldProc);
        }
        return null;
    }

    public static Protocol getHotdeployProtocol(String className, Protocol oldProt) throws Exception {
        Class<?> newProtocolClass = classes.get(className);
        if (newProtocolClass != null) {
            Constructor<?> constructor = newProtocolClass.getConstructor(Protocol.class);
            return (Protocol)constructor.newInstance(oldProt);
        }
        return null;
    }

    public static boolean hasNewProcedureClass() {
        return hasNewProcedureClass;
    }

    public static boolean hasNewProtocolClass() {
        return hasNewProtocolClass;
    }
}

